; This file is a reconstruction based on the listings provided by IBM. The
; macros are crafted such that the listings match.

; Segment override macro
; NB: This macro creates one unused local label
SEGOV   MACRO   SOV
LOCAL	L0
        IFIDN   <SOV>,<CS>
        DB      02EH
        ENDIF
        IFIDN   <SOV>,<DS>
        DB      03EH
        ENDIF
        IFIDN   <SOV>,<ES>
        DB      026H
        ENDIF
ENDM

; Compose an SMSW instruction
SMSW	MACRO	REG
	IFIDN	<REG>,<AX>
	DB	00FH,001H,0E0H
	ENDIF
ENDM

; Compose an LMSW instruction
LMSW	MACRO	REG
	IFIDN	<REG>,<AX>
	DB	00FH,001H,0F0H
	ENDIF
ENDM

; Compose an LIDT instruction
LIDT	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	BX,WORD PTR ADDR
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	001H
	ORG	OFFSET CS:L2	
ENDM

; Compose an LGDT instruction
LGDT	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	DX,WORD PTR ADDR
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	001H
	ORG	OFFSET CS:L2	
ENDM

; Compose an LLDT instruction
LLDT	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	DX,ADDR
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	000H
	ORG	OFFSET CS:L2	
ENDM

; Compose an LTR instruction
LTR	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	BX,ADDR
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	000H
	ORG	OFFSET CS:L2	
ENDM

; Compose an SIDT instruction
SIDT	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	CX,ADDR
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	001H
	ORG	OFFSET CS:L2	
ENDM

; Compose an SGDT instruction
SGDT	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	ADD	AX,ADDR
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	001H
	ORG	OFFSET CS:L2	
ENDM

; Compose an SLDT instruction
SLDT	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	ADD	ADDR,AX
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	000H
	ORG	OFFSET CS:L2	
ENDM

; Compose an STR instruction
STR	MACRO	ADDR
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	CX,ADDR
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	000H
	ORG	OFFSET CS:L2	
ENDM

; Compose an LAR instruction
LAR	MACRO	DST, SRC
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	DST,SRC
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	002H
	ORG	OFFSET CS:L2
ENDM

; Compose an LSL instruction
LSL	MACRO	DST, SRC
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	DST,SRC
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	003H
	ORG	OFFSET CS:L2
ENDM

; Compose an ARPL instruction
ARPL	MACRO	DST, SRC
LOCAL	L1, L2
L1	LABEL	BYTE
	MOV	DST,SRC
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	063H
	ORG	OFFSET CS:L2
ENDM

; Compose a VERR instruction
VERR	MACRO	REG
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	SP,REG
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	000H
	ORG	OFFSET CS:L2
ENDM

; Compose a VERW instruction
VERW	MACRO	REG
LOCAL	L1, L2
	DB	00FH
L1	LABEL	BYTE
	MOV	BP,REG
L2	LABEL	BYTE
	ORG	OFFSET CS:L1
	DB	000H
	ORG	OFFSET CS:L2
ENDM
